<?php 

session_start();

$message = '';
$volume = '';

if(!$_SESSION['login']){
	header("Location: login.php");
}

// load config file and read in data
$device_type = '';
$device_id = '';
$device_name = '';
$firmware_version = '';
$serial_number = trim($_ENV['APPLIANCE_SERIAL']);
$device_name_env = trim($_ENV['APPLIANCE_BOARD']);
$device_name_env = str_replace('"','', $device_name_env); // clear double quotes from $_ENV['APPLIANCE_BOARD']

// get mac_address
$mac_search = "/sbin/ifconfig eth0 | grep 'HWaddr'| awk '{ print $5}'";
$mac_address = shell_exec($mac_search);
$mac_address = trim($mac_address);
$mac_address = str_replace(':','', $mac_address); // clear : from mac address
$mac_address = strtoupper($mac_address); // all upper case

if(!$_ENV['APPLIANCE_PART']){
	// show error message
	$message = '<div class="isa_error"><i class="fa fa-times-circle"></i><div class="message_content">';
	$message .= 'There was a problem reading the appliance part number.';
	$message .= '</div></div>';

	$_SESSION['device_type'] = '0';
} else {
	$device_id = trim($_ENV['APPLIANCE_PART']);
	$device_name = 'Nyquist Appliance';

	if($device_id=='nq-voip'){
		$_SESSION['device_id'] = 'nq-voip';
		$_SESSION['pdf'] = 'SpeakerConfigurationManual.pdf';
		$device_name = $device_name_env;
	}
	if($device_id=='nq-s810v2'){
		$_SESSION['device_id'] = 'nq-s810v2';
		$_SESSION['pdf'] = 'SpeakerConfigurationManualv2.pdf';
		$device_name = $device_name_env;
		if($device_name ='Nyquist S810V2'){
			$device_name = 'Nyquist S1810V2';
		}
	}
	if($device_id=='nq-dev'){
		$_SESSION['device_id'] = 'nq-dev';
		$_SESSION['pdf'] = '';
		$device_name = $device_name_env;
	}
	if($device_id=='nq-mix'){
		$_SESSION['device_id'] = 'nq-mix';
		$_SESSION['pdf'] = 'MixerPreAmpManual.pdf';
		$device_name = $device_name_env;
	}
	if($device_id=='nq-asb'){
		$_SESSION['device_id'] = 'nq-asb';
		$_SESSION['pdf'] = 'ASBConfigurationManual.pdf';
		$device_name = $device_name_env;
	}
	if($device_id=='nq-io'){
		$_SESSION['device_id'] = 'nq-io';
		$_SESSION['pdf'] = 'IOControllerConfigurationManual.pdf';
		$device_name = $device_name_env;
	}
	if($device_id=='nq-ga10p' || $device_id=='nq-ga10pv'){
		$_SESSION['device_id'] = 'nq-ga10p';
		$_SESSION['pdf'] = 'GA10PConfigurationManual.pdf';
		$device_name = $device_name_env;
	}
	if(in_array($device_id, ['NQ-A2060','NQ-A2120','NQ-A2300'])){
		$_SESSION['device_id'] = 'nq-amp2c';
		$_SESSION['pdf'] = '2ChannelAmpManual.pdf';
		$device_name = $device_name_env;
	}
	if(in_array($device_id, ['NQ-A4060','NQ-A4120','NQ-A4300'])){
		$_SESSION['device_id'] = 'nq-amp4c';
		$_SESSION['pdf'] = '4ChannelAmpManual.pdf';
		$device_name = $device_name_env;
	}
	if($device_id=='nq-ga20p2'){
		$_SESSION['device_id'] = 'nq-ga20p2';
		$_SESSION['pdf'] = 'GA20P2Manual.pdf';
		$device_name = $device_name_env;
	}
	if(in_array($device_id, ['NQ-PA120','NQ-PA240','NQ-PA600'])){
		$_SESSION['device_id'] = 'nq-nqpaxxx';
		$_SESSION['pdf'] = 'PublicAddressAmpManual.pdf';
		$device_name = $device_name_env;
	}
	
	if($_SESSION['device_name']==''){ // manually set the device_name if it's not avaialble from SIP.config
		$_SESSION['device_name'] = $device_name;	
	}
	
	// set the help button links
	$_SESSION['help_dashboard'] = 'Using_the_Dashboard.htm#CSH_1';
	$_SESSION['help_firmware'] = 'Updating_Firmware.htm#CSH_2';
	$_SESSION['help_network'] = 'Setting_Network_Tab_Parameters.htm#CSH_3';
	$_SESSION['help_configuration'] = 'Setting_Configuration_Tab_Parameters.htm#CSH_4';
	$_SESSION['help_logs'] = 'Accessing_Log_Files.htm#CSH_5';
	$_SESSION['help_dsp'] = 'Setting_DSP_Parameters.htm';
}
?>

<!doctype html>
<html lang="en">
<head>
<style>

div.led {
	width: 20px;
	height: 20px;
	clip-path: circle(10px at center);
}
.gray {
	background: radial-gradient(circle, rgba(76, 76, 76, 1) 0%, rgba(0, 0, 0, 0) 100%);
}

.green {
	background: radial-gradient(circle, rgba(0, 255, 0, 1) 0%, rgba(0, 150, 0, 1) 100%);
}

.red {
	background: radial-gradient(circle, rgba(255, 0, 0, .5) 0%, rgba(255, 0, 0, 1) 100%);
}

#clip1, #clip2, #protection_status {
	class:"led gray";
}

</style>
<meta charset="UTF-8">
<link rel="shortcut icon" href="">
<link rel="stylesheet" href="/css/styles.css">
<link rel="stylesheet" href="/css/bootstrap.min.css">
<link rel="stylesheet" href="/css/font-awesome/css/font-awesome.min.css">
<link rel="icon" type="image/png" href="/favicon.png" />
<title><?php echo $_SESSION['device_type']; ?> (<?php echo $_SESSION['device_name']; ?>) - Dashboard</title>
</head>

<body>
<div class="container">

<?php include 'navbar.php';?>

<h4><strong><i class="fa fa-dashboard"></i> Dashboard</strong>&nbsp;&nbsp;<a href="/help/<?php echo $_SESSION['device_id']; ?>/#t=<?php echo $_SESSION['help_dashboard']; ?>" type="button" class="btn btn-xs btn-primary" target="_blank"><i class="fa fa-question-circle"></i></a></h4>
<div id="status"></div>
<div id="message_container"><?php echo $message; ?></div>
<br>
<table id="index_table" class="table-condensed">
<tr>
<td><strong>Device Type:</strong></td>
<td><input type="text" class="form-control" id="device_name" name="device_name" placeholder="" style="width:200px;" value="<?php echo $device_name; ?>" readonly></td>
<?php if($_SESSION['device_id']=='nq-asb'){ ?>
<td>&nbsp;&nbsp;&nbsp;</td>
<td><strong>Channel 1 Status:</strong></td>
<td><div id="clip1"></div></td>
<? } ?>
</tr>
<tr>
<td><strong>Serial Number:</strong></td>
<td><input type="text" class="form-control" id="serial_number" name="serial_number" placeholder="" style="width:200px;" value="<?php echo $serial_number; ?>" readonly>
<?php if($_SESSION['device_id']=='nq-asb'){ ?>
<td>&nbsp;&nbsp;&nbsp;</td>
<td><strong>Channel 2 Status:</strong></td>
<td><div id="clip2"></div></td>
<? } ?>
</tr>
<tr>
<td><strong>MAC Address:</strong></td>
<td><input type="text" class="form-control" id="mac_address" name="mac_address" placeholder="" style="width:200px;" value="<?php echo $mac_address; ?>" readonly></td>
<?php if($_SESSION['device_id']=='nq-asb'){ ?>
<td>&nbsp;&nbsp;&nbsp;</td>
<td><strong>Protection Status:</strong></td>
<td><div id="protection_status"></div></td>
<? } ?>
</tr>
<tr>
<td><strong>Firmware Version:</strong></td>
<td><input type="text" class="form-control" id="firmware_version" name="firmware_version" placeholder="" style="width:200px;" value="<?php echo $firmware_version; ?>" readonly></td>
<?php if($_SESSION['device_id']=='nq-asb'){ ?>
<td>&nbsp;&nbsp;&nbsp;</td>
<td><strong>Temperature:</strong></td>
<td><span id="temperature"></span></td>
<? } ?>
</tr>
</table>

<br><br>
<?php if($_SESSION['device_id'] == 'nq-voip' || $_SESSION['device_id'] == 'nq-asb') { // show volume control for the VoIP Speaker and Bridge Device ?>
<strong>Volume:&nbsp;&nbsp;<span id="volumeLabel"><?php echo $volume; ?></span></strong><br>
<input id="volume" name="volume" type="range" min="0" max="100" step="1" value="0" style="width:250px;" onChange="volumeChanged()"></input>
<? } ?>
</div>
<script src="/js/jquery.min.js"></script>
<script src="/js/bootstrap.min.js"></script>
</body>
</html>
<script>
// on page load

window.onload = function() {  
	
	var device_id = '<?php echo $_SESSION['device_id']; ?>';
	
	// only start the web socket for the ASB
	if(device_id=='nq-asb'){ 
		init_socket(); 
	}
	
	get_volume();
	get_firmware_status();
	$("#clip1").data({timeout:0, value:2, last:[]});
	$("#clip2").data({timeout:0, value:2, last:[]});
	$("#protection_status").data({timeout:0, value:2, last:[]});
	// clear message after 10 seconds
	setTimeout(function(){ 
		document.getElementById("message_container").innerHTML = '';
	}, 3000);
}

// web socket
var socket;
var id2class = [ "red", "green", "gray" ];
var sync_timeout;

function init_socket() {
	var host = "ws://" + location.hostname;
	try {
		socket = new WebSocket(host);
		console.log('WebSocket - status '+socket.readyState);
		socket.onopen    = function(msg) { 
			console.log("Welcome - status "+this.readyState); 
		};	
		
		socket.onmessage = function(msg) {
			var amp_status = JSON.parse(msg.data);
			var c1_data = $("#clip1").data();
			var c2_data = $("#clip2").data();
			var dis_data = $("#protection_status").data();
			var timeouts  = [];

			var temp = amp_status.temp;

			if ((c1_data.last.length == 0 && c1_data.value != amp_status.clip_ch1) || 
					(amp_status.clip_ch1 != c1_data.last[c1_data.last.length - 1])) {
				c1_data.last.push(amp_status.clip_ch1);
				c1_data.timeout = Math.round(300 / c1_data.last.length);
				timeouts.push(c1_data.timeout);
			}

			if ((c2_data.last.length == 0 && c2_data.value != amp_status.clip_ch2) || 
					(amp_status.clip_ch2 != c2_data.last[c2_data.last.length - 1])) {
				c2_data.last.push(amp_status.clip_ch2);
				c2_data.timeout = Math.round(300 / c2_data.last.length);
				timeouts.push(c2_data.timeout);
			}

			if ((dis_data.last.length == 0 && dis_data.value != amp_status.dis_rp) || 
					(amp_status.dis_rp != dis_data.last[dis_data.last.length - 1])) {
				dis_data.last.push(amp_status.dis_rp);
				dis_data.timeout = Math.round(300 / dis_data.last.length);
				timeouts.push(dis_data.timeout);
			}

			timeouts.sort(function(a, b){return a - b});
			clearTimeout(sync_timeout);
			sync_timeout = setTimeout(resync_LED, timeouts[0], timeouts[0]);
			document.getElementById("temperature").innerHTML = temp + '&#8451;';
		};
		
		socket.onclose   = function(msg) { 
			console.log("Disconnected - status "+this.readyState); 
			$("#clip1").data({timeout:0, value:2, last:[]});
			$("#clip2").data({timeout:0, value:2, last:[]});
			$("#protection_status").data({timeout:0, value:2, last:[]});
			document.getElementById("clip1").setAttribute("class", "led gray");
			document.getElementById("clip2").setAttribute("class", "led gray");
			document.getElementById("protection_status").setAttribute("class", "led gray");
			document.getElementById("temperature").innerHTML = '';
		};
	}
	catch(ex){ 
		console.log(ex); 
	}
}
$('#volume').on('input', function(){
	$("#volumeLabel").text(volume.value);
});

function resync_LED(timeout) {
	var c1_data = $("#clip1").data();
	var c2_data = $("#clip2").data();
	var dis_data = $("#protection_status").data();
	var timeouts  = [];

	if (c1_data.timeout) {
		if ((c1_data.timeout - timeout) > 0) {
			c1_data.timeout -= timeout;
			timeouts.push(c1_data.timeout);
		}
		else {
			c1_data.value = c1_data.last.shift();
			document.getElementById("clip1").setAttribute("class", "led " + id2class[c1_data.value]);
			if (!c1_data.last.length)
				c1_data.timeout = 0;
			else
				timeouts.push(c1_data.timeout);
		}
	}

	if (c2_data.timeout) {
		if ((c2_data.timeout -timeout) > 0) {
			c2_data.timeout -= timeout;
			timeouts.push(c2_data.timeout);
		}
		else {
			c2_data.value = c2_data.last.shift();
			document.getElementById("clip2").setAttribute("class", "led " + id2class[c2_data.value]);
			if (!c2_data.last.length)
				c2_data.timeout = 0;
			else
				timeouts.push(c2_data.timeout);
		}
	}

	if (dis_data.timeout) {
		if ((dis_data.timeout - timeout) > 0) {
			dis_data.timeout -= timeout;
			timeouts.push(dis_data.timeout);
		}
		else {
			dis_data.value = dis_data.last.shift();
			document.getElementById("protection_status").setAttribute("class", "led " + id2class[dis_data.value]);
			if (!dis_data.last.length)
				dis_data.timeout = 0;
			else
				timeouts.push(dis_data.timeout);
		}
	}

	if(timeouts.length) {
		timeouts.sort(function(a, b){return a - b});
		sync_timeout = setTimeout(resync_LED, timeouts[0], timeouts[0]);
	}

}
// get volume
function get_volume(){
	
	var xmlhttp=new XMLHttpRequest();
    	xmlhttp.onreadystatechange=function() {
        	if (xmlhttp.readyState==4 && xmlhttp.status==200) {
				// success 
				//console.log(xmlhttp.responseText);
				var match = xmlhttp.responseText.match(/\d+/g);
				if(match !== null){
				   var volume = 0;
					if(match.length>0){
					   volume = match[0];
					 }
					document.getElementById("volume").value = volume;
					$("#volumeLabel").text(volume);	
				 }
        	}
		}
	 	xmlhttp.open("GET","scripts.php?s=get_volume",true);
   		xmlhttp.send();
}
// save volume
function volumeChanged(){
	
	document.getElementById("status").innerHTML = '<i class="fa fa-refresh fa-spin fa-fw"></i> <strong>Processing ... </strong>';
	
	var volume = document.getElementById("volume");
	
	var xmlhttp=new XMLHttpRequest();
    	xmlhttp.onreadystatechange=function() {
        	if (xmlhttp.readyState==4 && xmlhttp.status==200) {
				// success 
				//alert(xmlhttp.responseText);
				
				document.getElementById("status").innerHTML = '';
				document.getElementById("message_container").innerHTML = '<div class="isa_success"><i class="fa fa-check"></i><div class="message_content">Volume updated.<br></div></div><br>';
				
				<!-- clear message after 10 seconds -->
				setTimeout(function(){ 
					document.getElementById("message_container").innerHTML = '';
				}, 3000);
        	}
		}
	 	xmlhttp.open("GET","scripts.php?s=set_volume&v=" + volume.value,true);
   		xmlhttp.send();
}
function set_volume_control(stream, label){
	
	document.getElementById("status").innerHTML = '<i class="fa fa-refresh fa-spin fa-fw"></i> <strong>Processing ... </strong>';
	
	var volume = document.getElementById(stream);
	
	var xmlhttp=new XMLHttpRequest();
    	xmlhttp.onreadystatechange=function() {
        	if (xmlhttp.readyState==4 && xmlhttp.status==200) {
				// success 
				//alert(xmlhttp.responseText);
				
				document.getElementById("status").innerHTML = '';
				document.getElementById("message_container").innerHTML = '<div class="isa_success"><i class="fa fa-check"></i><div class="message_content">' + label + ' Updated.<br></div></div><br>';
				
				<!-- clear message after 10 seconds -->
				setTimeout(function(){ 
					document.getElementById("message_container").innerHTML = '';
				}, 3000);
        	}
		}
	 	xmlhttp.open("GET","scripts.php?s=set_volume_control&v=" + volume.value + '&d=' + stream,true);
   		xmlhttp.send();
}
function get_volume_control(stream){
	
	var xmlhttp=new XMLHttpRequest();
    	xmlhttp.onreadystatechange=function() {
        	if (xmlhttp.readyState==4 && xmlhttp.status==200) {
				// success 
				//alert(xmlhttp.responseText);
				var match = xmlhttp.responseText.match(/\d+/);
				
				var volume = (match[0]);
				document.getElementById(stream).value = volume;
				$("#" + stream + "_label").text(volume);	

        	}
		}
	 	xmlhttp.open("GET","scripts.php?s=get_volume_control&d=" + stream,true);
   		xmlhttp.send();
}
function get_firmware_status(){
	
	var xmlhttp=new XMLHttpRequest();
    	xmlhttp.onreadystatechange=function() {
        	if (xmlhttp.readyState==4 && xmlhttp.status==200) {
				// success 
				//alert(xmlhttp.responseText);
				
				var dataArray = xmlhttp.responseText.split("|");
				var old_version = dataArray[0];
				var new_version = dataArray[1];
				
				// set firmware version
				document.getElementById("firmware_version").value = old_version;
        	}
		}
	 	xmlhttp.open("GET","scripts.php?s=get_firmware_status",true);
   		xmlhttp.send();
}
</script>